﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using MvcCoffeeShop.DataTransferObjects;
using System.Data;
using System.Data.SqlClient;
using System.Data.Sql;




namespace MvcCoffeeShop
{
    namespace DataAccess
    {
        public class MvcCoffeeShopDA : DataAccessBase, IDisposable
        {
            String mstrConn;
            DBSafeConvert oConvertTo = new DBSafeConvert();

            public MvcCoffeeShopDA(String strConn)
            {
                mstrConn = strConn;
            }

            public ProductDTO GetProduct(int ProductID)
                {

                    try
                    {
                         ProductDTO oProduct;
                         oProduct = new ProductDTO();
                       
                         var param = new SqlParameter("@ProductID", ProductID);

                         var oDataTable = new DataTable();
                         oDataTable = ExecuteDataTable(mstrConn, "sp_GetProduct", param);

                         oProduct.ProductID = oConvertTo.SafeInt(oDataTable.Rows[0]["ProductID"]);
                         oProduct.ProductName = oConvertTo.SafeString(oDataTable.Rows[0]["ProductName"]);
                         oProduct.ProductDesc = oConvertTo.SafeString(oDataTable.Rows[0]["ProductDesc"]);
                         oProduct.SupplierID = oConvertTo.SafeInt(oDataTable.Rows[0]["SupplierID"]);
                         oProduct.Quantity = oConvertTo.SafeInt(oDataTable.Rows[0]["Quantity"]);
                         oProduct.UnitPrice = oConvertTo.SafeDouble(oDataTable.Rows[0]["UnitPrice"]);
                         oProduct.PicturePath = oConvertTo.SafeString(oDataTable.Rows[0]["PicturePath"]);                    
                                           
                        return oProduct;
                     
                    }
                catch (Exception e)
                    {
                       throw e;
                    }
               

            }

            //Functions for grabbing data
            public List<ProductDTO> GetProducts()
            {
                try
                {
                    ProductDTO oProduct;
                    var oProducts = new List<ProductDTO>();

                    var oDataTable = new DataTable();
                    oDataTable = ExecuteDataTable(mstrConn, "sp_GetProducts");
                    
                            foreach (DataRow row in oDataTable.Rows)
                             {
                                    oProduct = new ProductDTO();

                                    oProduct.ProductID = oConvertTo.SafeInt(row["ProductID"]);
                                    oProduct.ProductName = oConvertTo.SafeString(row["ProductName"]);
                                    oProduct.ProductDesc = oConvertTo.SafeString(row["ProductDesc"]);
                                    oProduct.SupplierID = oConvertTo.SafeInt(row["SupplierID"]);
                                    oProduct.Quantity = oConvertTo.SafeInt(row["Quantity"]);
                                    oProduct.UnitPrice = oConvertTo.SafeDouble(row["UnitPrice"]);
                                    oProduct.PicturePath = oConvertTo.SafeString(row["PicturePath"]);
                                    oProducts.Add(oProduct);
                            }
                     
                            return oProducts;
                     
                }
                catch (Exception e)
                {
                    throw e;
                }
               

            }


            public void Dispose()
            {
                throw new NotImplementedException();
            }
        }
    }
}