﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DAL;
using System.Data;
using System.Data.Entity;
using MvcCoffeeShop.DataTransferObjects;
using MvcCoffeeShop.Repository.Helpers;
namespace MvcCoffeeShop.Repository
{
    public class UnitOfWork : IDisposable
    {

        private MvcCoffeeShopEntities context = new MvcCoffeeShopEntities();
        private GenericRepository<Product,ProductDTO> productRepository;



        public GenericRepository<Product, ProductDTO> ProductRepository
        {
            get
            {
                if (productRepository == null)
                {
                    ProductDTO productDTO=new ProductDTO();
                    Product product = new Product();
                    this.productRepository = new GenericRepository<Product, ProductDTO>(context, product, productDTO);
                   
                }
                return productRepository;
            }
        }
       
       

        public void Save()
        {
            context.SaveChanges();
        }

        private bool disposed = false;

        protected virtual void Dispose(bool disposing)
        {
            if (!this.disposed)
            {
                if (disposing)
                {
                    context.Dispose();
                }
            }
            this.disposed = true;
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }
    }
}
